import os
from zc.async.testing import wait_for_result
from zope.event import notify
from zope.interface.verify import verifyClass, verifyObject
from zope.component import getUtility
from waeup.kofa.interfaces import IJobManager
from waeup.kofa.students.reports.session_results_presentation import (
    get_students, ISessionResultsPresentation)
from waeup.kofa.students.tests.test_catalog import CatalogTestSetup
from waeup.kofa.students.tests.test_browser import StudentsFullSetup
from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
from waeup.kofa.browser.tests.test_pdf import samples_dir

from waeup.aaue.students.reports.session_results_presentation import CustomSessionResultsPresentation

from waeup.aaue.testing import FunctionalLayer


class SessionResultsPresentationTests(CatalogTestSetup):

    layer = FunctionalLayer

    def test_iface(self):
        # ensure we fullfill interface contracts
        obj = CustomSessionResultsPresentation('fac1', 'dep1', 'CERT1', 2010, 100)
        verifyClass(ISessionResultsPresentation, CustomSessionResultsPresentation)
        verifyObject(ISessionResultsPresentation, obj)
        return

    def test_get_students(self):
        result = get_students('fac1', 'dep1', 'CERT1', 2010, 100)
        self.assertEqual(result,
            [[(u'E1000000', u'1234', u'TESTER, Bob')], [], [], [], [], [], []])
        self.student['studycourse']['100']['Course1'].score = 60
        self.student['studycourse']['100']['Course1'].ca = 10
        result = get_students('fac1', 'dep1', 'CERT1', 2010, 100)
        self.assertEqual(result,
            [[], [], [], [], [], [(u'E1000000', u'1234', u'TESTER, Bob')], []])
        return


    def test_create_pdf(self):
        self.certificate.degree = 'BA(FS)'
        report = CustomSessionResultsPresentation('fac1', 'dep1', 'CERT1', 2010, 100)
        result = report.create_pdf('JOB_ID')
        self.assertTrue(result.startswith('%PDF-'))
        path = os.path.join(samples_dir(), 'session_results_presentation.pdf')
        open(path, 'wb').write(result)
        print "Sample session_results_presentation.pdf written to %s" % path
        return

 